<?php

namespace App\Http\Requests;


use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class CobonRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = ['super_admin', 'admin'];
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('cobons'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        
      $start = request('start_date');
      $end = request('end_date');
      
        
        $rules=[
                'discount_type'=>'required',
                'discount_amount'=>'required',
                'start_date'=>'required',
                'end_date'=>'required',
                'type'=>'required',
            
        ];
        if($end < $start){
            $rule = [
                'expired'=>'required'
                ];
          $rules= array_merge($rules, $rule);
      }

         foreach (languages() as $lang) {
            $lang_rules=[
                'title_'.$lang->local=> 'required',
            ];
            $rules= array_merge($rules, $lang_rules);
        }
       

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('cobons');
        $attributes= [
            'discount_type'=>  __('cobons.discount_type'),
            'discount_amount'=>  __('cobons.discount_amount'),
            'start_date'=>  __('cobons.start_date'),
            'end_date'=>  __('cobons.end_date'),
            'type'=>  __('cobons.type'),
           
            
        ];
         foreach (languages() as $lang) {
            $lang_attributes=[
                'title_'.$lang->local => $service->{'title_'.$lang->local} ?? __('cobons.title'),
            ];
            $attributes= array_merge($attributes, $lang_attributes);
}
        return $attributes;
    }
public function messages(){
    return [
        'expired.required'=>__('cobons.expired')
        ];
}
    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
